unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl, zlibex, ExtCtrls;

const
  UM_ThreadDoneMsg = WM_User + 8;


type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    btnZip: TBitBtn;
    btnQuit: TBitBtn;
    lbThreadList: TListBox;
    Label3: TLabel;
    Bevel1: TBevel;
    Label4: TLabel;
    Edit2: TEdit;
    btnUnzip: TBitBtn;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    procedure btnQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnZipClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnUnzipClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
     procedure UMThreadDone(var msg:TMessage); message UM_ThreadDoneMsg;
  public

  public
    { Public declarations }
  end;

  TZThread=class(TThread)
  private
    { Private declarations }
    FIn : string ;
    FOut : string ;
    Fh : THandle ;
    FiNum : integer ;
  protected
    procedure Execute; override;
  public
    constructor Create(sIn, sOut:string;h:THandle;iNum:integer);
  end;

var
  Form1: TForm1;
  zta : array[1..10] of TZThread ;

implementation
{$R *.DFM}

constructor TZThread.Create(sIn, sOut:string;h:THandle;iNum:integer);
begin
  FIn:=sIn ;
  FOut:=sOut ;
  Fh:=h ;
  FiNum:=iNum ;
  
  FreeOnTerminate := false;
  inherited Create(False);
end;

procedure TZThread.Execute;
var
  fsIn, fsOut : TFileStream ;
  zcs : TZCompressionStream ;
begin
  fsIn:=TFileStream.Create(FIn,fmOpenRead) ;
  fsOut:=TFileStream.create(FOut,fmCreate) ;

  zcs:=TZCompressionStream.Create(fsOut) ;
  zcs.CopyFrom(fsIn,0) ;
  zcs.free ;
  
  fsIn.free ;
  fsOut.free ;
  PostMessage(Fh,UM_ThreadDoneMsg,$AAAA,FiNum) ;
end ;

procedure TForm1.UMThreadDone(var msg: TMessage);
var
  s : string ;
  i : integer ;
begin
  // ˬdO_Xk MSG, קKOH~e
  if msg.WParam<>$AAAA then
    exit ;

  s:=inttostr(msg.lParam) ;
  i:=lbThreadList.Items.IndexOf(s) ;
  if i>=0 then
    lbThreadList.Items.Delete(i) ;

  zta[msg.lParam].Terminate ;
  zta[msg.lParam].WaitFor ;
  zta[msg.lParam]:=nil ;
end;



procedure TForm1.btnQuitClick(Sender: TObject);
begin
  close ;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer ;
begin
  for i:=1 to high(zta) do
    zta[i]:=nil ;
end;

procedure TForm1.btnZipClick(Sender: TObject);
var
  i : integer ;
  sIn, sOut : string ;
begin
  if not DirectoryExists(Edit1.text) then
    ForceDirectories(Edit1.text) ;
    
  sIn:=FileListBox1.FileName ;
  if (not FileExists(sIn)) or (CompareText(ExtractFileExt(sIn),'.myz')=0) then
    begin
    ShowMessage('Х@ө|Yɮ') ;
    exit ;
    end ;

  sOut:=Edit1.Text+'\'+ExtractFileName(sIn)+'.MYZ' ;

  for i:=1 to 10 do
    begin
    if zta[i]=nil then
      begin
      lbThreadList.Items.Add(inttostr(i)) ;
      zta[i]:=TZThread.Create(sIn,sOut,handle,i) ;
      break ;
      end ;
    end ;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if OpenDialog1.InitialDir='' then
    OpenDialog1.InitialDir:=Edit1.Text ;

  if OpenDialog1.Execute then
    Edit2.Text:=OpenDialog1.FileName ;
end;

procedure TForm1.btnUnzipClick(Sender: TObject);
var
  sIn, sOut : string ;
  fsIn, fsOut : TFileStream ;
  zds : TZDecompressionStream ;
begin
  sIn:=Edit2.Text ;
  if (not FileExists(sIn)) or (CompareText(ExtractFileExt(sIn),'.myz')<>0) then
    begin
    ShowMessage('Х@ӤwgYLɮ(*.MYZ)AIY.') ;
    exit ;
    end ;

  sOut:=ChangeFileExt(sIn,'') ;

  Screen.Cursor:=crHourGlass ;

  fsIn:=TFileStream.Create(sIn,fmOpenRead) ;
  fsOut:=TFileStream.Create(sOut,fmCreate) ;

  zds:=TZDecompressionStream.Create(fsIn) ;
  fsOut.CopyFrom(zds,0) ;
  zds.Free ;

  fsIn.free ;
  fsOut.Free ;

  Screen.Cursor:=crDefault ;
  ShowMessage('Y.') ;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer ;
begin
  // ˬd@Thread ]൲
  for i:=1 to 10 do
    begin
    if zta[i]<>nil then
      begin
      Action:=caNone ;
      exit ;
      end ;
    end ;
end;

end.
